/***************************************************************************
 *   Copyright (C) 2007 by Κωνσταντίνος Σμάνης   *
 *   kon.smanis@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation                                              *
 *   51 Franklin Street, Fifth Floor                                       *
 *   Boston, MA 02110-1301 USA                                             *
 ***************************************************************************/

#include "preview.h"

Preview::Preview( QString path,  QWidget* parent ) : QDialog( parent )
{
	setupUi( this );

	if ( QFile::exists( "/tmp/qgrubeditor.xpm" ) )
		QFile::remove( "/tmp/qgrubeditor.xpm" );

	if ( QFile::copy( path, "/tmp/qgrubeditor.xpm.gz" ) )
	{
		QProcess gzip;
		gzip.start( "gzip", QStringList() << "-d" << "/tmp/qgrubeditor.xpm.gz" );
		gzip.waitForFinished();

		labelSplash->setPixmap( QPixmap( QString( "/tmp/qgrubeditor.xpm" ) ) );
	}
}
Preview::~Preview()
{
	QFile::remove( "/tmp/qgrubeditor.xpm" );
}
